//
//  Extensions.swift
//  CrashReproCase
//
//  Created by Austin Zheng on 6/15/16.
//  Copyright © 2016 Austin Zheng. All rights reserved.
//

import Cocoa

// NOTE: This bridging header isn't strictly part of the framework "CrashReproCase". It's meant for a consumer of the
// framework to include directly in their project in order to provide their app with additional Swift-specific
// functionality. We model this by making this .swift file a member of the 'CrashReproCaseTests' target (which stands in
// for our application), and configuring our test case target with a bridging header.
//
// IMPORTANT: This means you will NOT see the problem if you build the framework! You need to attempt to run the tests
// in order for it to show up.

public class RLMUniversalIterator : IteratorProtocol {
  let parent: RLMCollectionProtocol
  init(_ item: RLMCollectionProtocol) { parent = item }

  public func next() -> NSObject? { return nil }
}

extension RLMZeroElementCollection : Sequence {
  public func makeIterator() -> RLMUniversalIterator {
    // Note that the problem still occurs even if you comment out the 'return ...' line and replace it with fatalError()
    return RLMUniversalIterator(self)
  }
}
